﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
'version: 2.21
#Region EVENTS 
#Event: Click (Index As Int, Text As String)
#End Region

#Region Designer properties 
#DesignerProperty: Key: FillColor, DisplayName: Fill Color, FieldType: Color, DefaultValue: 0xFFFFFFFF
#DesignerProperty: Key: MenuItemType, DisplayName: MenuItemType, FieldType: String, DefaultValue: Both, List: Both|Image|Text
#DesignerProperty: Key: StrokeColor1, DisplayName: Stroke color, Description: Stroke gradient first color, FieldType: Color, DefaultValue: 0xFF0000FF
#DesignerProperty: Key: StrokeColor2, DisplayName: Stroke color, Description: Stroke gradient second color, FieldType: Color, DefaultValue: 0xFFCCCCFF
#DesignerProperty: Key: StrokeGradientOrientation, DisplayName: Orientation, Description: Stroke gradient orientation, FieldType: String, DefaultValue: TL_BR, List: TL_BR|TOP_BOTTOM|TR_BL|LEFT_RIGHT|RIGHT_LEFT|BL_TR|BOTTOM_TOP|BR_TL|RECTANGLE
#End Region

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView 'ignore
	Private xui As XUI 'ignore
	Private bc As BitmapCreator
	Private iv As B4XView
	Public Items As List
	Private Centers As List
	Public lstLabels As List
	Public lstImageViews As List
	Private pnl As B4XView
	Private UpdatedCenters As List
	Public FillColor As Int
	Public PressedFilledColor As Int = xui.Color_Black
	Public PressedTextColor As Int = xui.Color_White
	Private TextColor As Int
	Private PressedIndex As Int
	
	Public Const MENU_ITEM_TYPE_BOTH As String = "Both"
	Public Const MENU_ITEM_TYPE_IMAGE As String = "Image"
	Public Const MENU_ITEM_TYPE_TEXT As String = "Text"
	Private mMenuItemType As String

	Private GradientBrush As BCBrush
	Private StrokeColor1, StrokeColor2 As Int
	Private StrokeGradientOrientation As String
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	Items.Initialize
	Dim s As Float = CosD(30)
	Centers.Initialize
	Centers.Add(Array As Float(0, 0))
	Centers.Add(Array As Float(-1.5, -s))
	Centers.Add(Array As Float(0, -2 * s))
	Centers.Add(Array As Float(1.5, -1 * s))
	Centers.Add(Array As Float(1.5, 1 * s))
	Centers.Add(Array As Float(0, 2 * s))
	Centers.Add(Array As Float(-1.5, 1 * s))
	lstLabels.Initialize
	lstImageViews.Initialize
	UpdatedCenters.Initialize
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	mMenuItemType = Props.Get("MenuItemType")
	FillColor = xui.PaintOrColorToColor(Props.Get("FillColor"))
	StrokeColor1 = xui.PaintOrColorToColor(Props.Get("StrokeColor1"))
	StrokeColor2 = xui.PaintOrColorToColor(Props.Get("StrokeColor2"))
	StrokeGradientOrientation = Props.Get("StrokeGradientOrientation")
	Dim iv1 As ImageView
	iv1.Initialize("")
	iv = iv1
	mBase.AddView(iv, 0, 0, 0, 0)
	mBase.SetColorAndBorder(xui.Color_Transparent, 0, 0, 0)
	Dim origLabel As B4XView = Lbl
	TextColor = origLabel.TextColor
	For i = 0 To Centers.Size - 1
		If mMenuItemType = MENU_ITEM_TYPE_IMAGE Or mMenuItemType = MENU_ITEM_TYPE_BOTH Then
			Dim NewImageView As ImageView
			NewImageView.Initialize("")
			Dim xImv As B4XView
			xImv = NewImageView
			mBase.AddView(xImv, 0, 0, 0, 0)
			lstImageViews.Add(xImv)
		End If

		If mMenuItemType = MENU_ITEM_TYPE_TEXT Or mMenuItemType = MENU_ITEM_TYPE_BOTH Then
			Dim NewLabel As Label
			NewLabel.Initialize("")
			Dim xlbl As B4XView = NewLabel
			xlbl.TextSize = origLabel.TextSize
			xlbl.TextColor = TextColor
			xlbl.SetTextAlignment("CENTER", "CENTER")
			mBase.AddView(xlbl, 0, 0, 0, 0)
			lstLabels.Add(xlbl)
		End If
	Next
	pnl = xui.CreatePanel("pnl")
	mBase.AddView(pnl, 0, 0, 0, 0)
	If mBase.Width > 0 Then Base_Resize(mBase.Width, mBase.Height)
End Sub

#Region PROPERTIES 

' ItemType - pass one of the constants provided by this class:
' MENU_ITEM_TYPE_IMAGE - Image only
' MENU_ITEM_TYPE_TEXT - Text only
' MENU_ITEM_TYPE_BOTH - both
Public Sub setMenuItemType(ItemType As String)
	mMenuItemType = ItemType
End Sub
Public Sub getMenuTimeType As String
	Return mMenuItemType
End Sub

#End Region

#Region PUBLIC METHODS  

Public Sub Update
	bc.DrawRect(bc.TargetRect, xui.Color_Transparent, True, 0)
	Dim h As Int = Min(iv.Height,  iv.Width)
	Dim r As Float = (h - 6dip) / 6
	UpdatedCenters.Clear
	For i = 0 To Centers.Size - 1
		Dim c() As Float = Centers.Get(i)
		Dim cx As Float = c(0) * r + h / 2
		Dim cy As Float = c(1) * r + h / 2
		If mMenuItemType = MENU_ITEM_TYPE_TEXT Or mMenuItemType = MENU_ITEM_TYPE_BOTH Then
			Dim lbl As B4XView = lstLabels.Get(i)
		End If
		If mMenuItemType = MENU_ITEM_TYPE_IMAGE Or mMenuItemType = MENU_ITEM_TYPE_BOTH Then
			Dim xImv As B4XView = lstImageViews.Get(i)
		End If
		If i <= Items.Size - 1 Then
			If mMenuItemType = MENU_ITEM_TYPE_TEXT Or mMenuItemType = MENU_ITEM_TYPE_BOTH Then
				lbl.Text = Items.Get(i)
				lbl.SetLayoutAnimated(0, iv.Left + (cx - r), iv.Top + (cy - r), (r * 2), (r * 2))
			End If
			If mMenuItemType = MENU_ITEM_TYPE_IMAGE Or mMenuItemType = MENU_ITEM_TYPE_BOTH Then
				xImv.SetLayoutAnimated(0, iv.Left + (cx - r * .7), iv.Top + (cy - r * .7), (r * 1.4), (r * 1.4))
			End If
			UpdatedCenters.Add(Array As Float(cx, cy))
			DrawCell(cx + 0.5, cy + 0.5, r + 0.5, FillColor, 4dip)
		Else
			If mMenuItemType = MENU_ITEM_TYPE_TEXT Or mMenuItemType = MENU_ITEM_TYPE_BOTH Then
				lbl.Text = ""
			End If
		End If
	Next
	bc.SetBitmapToImageView(bc.Bitmap, iv)
End Sub

#End Region

#Region PRIVATE METHODS 

Private Sub DrawCell (CenterX As Int, CenterY As Int, Radius As Int, vFillColor As Int, Thickness As Int)
	Dim s As Float = Radius * CosD(30)
	Dim p As BCPath
	p.Initialize(CenterX - Radius / 2, CenterY - s)
	p.LineTo(CenterX + Radius / 2, CenterY - s)
	p.LineTo(CenterX + Radius, CenterY)
	p.LineTo(CenterX + Radius / 2, CenterY + s)
	p.LineTo(CenterX - Radius / 2, CenterY + s).LineTo(CenterX - Radius, CenterY)
	bc.DrawPath(p, vFillColor, True, 0)
	bc.DrawPath2(p, GradientBrush, False, Thickness)
End Sub

#End Region

#Region EVENTS 

Private Sub Base_Resize (Width As Double, Height As Double)
	Dim mn As Double = Min(Width, Height)
	iv.SetLayoutAnimated(0, Width / 2 - mn / 2, Height / 2 - mn / 2, mn, mn)
	pnl.SetLayoutAnimated(0, iv.Left, iv.Top, iv.Width, iv.Height)
	bc.Initialize(iv.Width, iv.Height)
	bc.FillGradient(Array As Int(StrokeColor1, StrokeColor2), bc.TargetRect, StrokeGradientOrientation)
	GradientBrush = bc.CreateBrushFromBitmap(bc.Bitmap)
	Update
End Sub

Private Sub Pnl_Touch (Action As Int, X As Float, Y As Float)
	If Action = pnl.TOUCH_ACTION_DOWN Then
		Dim h As Int = Min(iv.Height,  iv.Width)
		Dim r As Float = (h - 6dip) / 6
		Dim MinR As Float = r * 1000
		Dim MinI As Int
		For i = 0 To UpdatedCenters.Size - 1
			Dim cc() As Float = UpdatedCenters.Get(i)
			Dim dist As Float = Sqrt(Power(cc(0) - x, 2) + Power(cc(1) - y, 2))
			If dist < MinR Then
				MinR = dist
				MinI = i
			End If
		Next
		If MinR < r Then
			Dim cc() As Float = UpdatedCenters.Get(MinI)
			DrawCell(cc(0) + 0.5, cc(1) + 0.5, r + 0.5, PressedFilledColor, 3dip)
			If mMenuItemType = MENU_ITEM_TYPE_TEXT Or mMenuItemType = MENU_ITEM_TYPE_BOTH Then
				Dim lbl As B4XView = lstLabels.Get(MinI)
				lbl.TextColor = PressedTextColor
			End If
			bc.SetBitmapToImageView(bc.Bitmap, iv)
			CallSub3(mCallBack, mEventName & "_Click", MinI, Items.Get(MinI))
			PressedIndex = PressedIndex + 1
			Dim MyIndex As Int = PressedIndex
			Sleep(100)
			If mMenuItemType = MENU_ITEM_TYPE_TEXT Or mMenuItemType = MENU_ITEM_TYPE_BOTH Then
				lbl.TextColor = TextColor
			End If
			If MyIndex <> PressedIndex Then Return
			Update
		End If
	End If
End Sub

#End Region
